<template>
    <div>
        <main>
        <img src="../../assets/icon-left-font-monochrome-white.png" alt="Logo Groupomania">

        <div id="profile-container" class="align-items-center">
            <h1 class="py-3">Profil Utilisateur</h1>
            <div >
                <form class="d-flex justify-content-around align-items-center my-4">
                <div id="user-info">
                    <label for="user-firstname" class="text-start mb-1 mt-0"><span class="little-font">Prénom:</span> {{user.firstname}}</label>
                    <br>
                    <input id="user-firstname" type="text" v-model="user.firstname" v-if="isOpen" >
                    <br>
                    <label for="user-lastname" class="text-start mb-1 mt-2"><span class="little-font">Nom:</span> {{user.lastname}}</label>
                    <br>
                    <input id="user-lastname" type="text" v-model="user.lastname" v-if="isOpen">
                </div>
                <div class="d-flex flex-column">
                    <img v-show="!isAvatarHidden" id="image-user" :src="user.image" alt="Photo de profil">
                    <label v-if="isOpen" for="file-upload" class="custom-file-upload text-left mt-2">Modifier l'image</label>
                    <input name="file-upload" id="file-upload" type="file" v-on:change="onFileSelected"> 
                    <div v-if="selectedFile !== ''" class="text-light little-font cuted-text">{{ selectedFile }}</div>
                      
                </div>
                </form>
            </div>
            <div id="buttons" class="pb-3">
                <button v-if="!isOpen" class="btn btn-edit text-light my-3" @click="isOpen = true">Modifier le profil</button>
                <button v-else class="btn btn-edit text-light my-3" @click="sendEditProfile()">Sauvegarder les changements</button>
                <br>
                <button class="btn btn-delete text-light little-font px-1 py-0 font-weight-bold" v-if="isOpen" @click="sendDeleteProfile()">Supprimer le profil</button>
                <button class="btn btn-delete text-light little-font px-1 py-0 font-weight-bold" v-else @click="deconnexion()">Se déconnecter</button>
            </div>
        </div>
        </main>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                name: 'EditProfile',
                currentUserId: '',
                currentUserIsAdmin: false,
                user: {
                    firstname: '',
                    lastname: '',
                    image: '',
                },
                isOpen:false,
                buttonText:'Modifier le profil',
                selectedFile: '',
                isAvatarHidden:false
            }
        },
        created() {
            this.getUser()
        },
        methods: {
            deconnexion(){
                localStorage.clear()
                window.location.href = "/connexion"
            },
            getUser() {
                const axios = require('axios')
                const jwt = require('jsonwebtoken')
                const token = JSON.parse(localStorage.getItem('token'))
                const decodedToken = jwt.verify(token, 'RANDOM_TOKEN_SECRET');
                const userId = decodedToken.userId;
                const url = `http://localhost:3000/api/users/${userId}`
                const config = {
                    headers: {
                        Authorization: `Bearer ${token}`
                    }
                }
                axios.get(url, config)
                .then((res) => {
                    // return res.data
                    //console.log(res.data.image);
                    this.user.image = res.data.image
                    //console.log(this.user.image);
                    this.user.firstname = res.data.firstname
                    this.user.lastname = res.data.lastname
                    this.currentUserId = res.data.id
                    this.currentUserIsAdmin = res.data.isAdmin
                })
                .catch(err => err.message)
            },
            sendEditProfile(){
                const axios = require('axios')
                const id = this.currentUserId
                const url = `http://localhost:3000/api/users/update/${id}`
                //console.log(url);
                const fd = new FormData()
                fd.append('firstname',this.user.firstname)
                fd.append('lastname',this.user.lastname)
                if (this.selectedFile !== '') {
                    fd.append('image', this.user.image, this.selectedFile)
                }else{
                    fd.append('image',this.user.image)
                }
                const token = JSON.parse(localStorage.getItem('token'))
                const config = {
                    headers: {
                        'Authorization': `Bearer ${token}`
                    }
                }
                // for (var value of fd.values()) {
                //     //console.log(value);
                // }
                axios.put(url,fd,config)
                .then(() => window.location.href= '/')
                .catch(err => console.log(err))
            },
            onFileSelected(event) {
                this.isAvatarHidden = true
                this.user.image = event.target.files[0]
                this.selectedFile = event.target.files[0].name
            },
            sendDeleteProfile(){
                const axios = require('axios')
                const id = this.currentUserId
                const url = `http://localhost:3000/api/users/delete/${id}`
                const token = JSON.parse(localStorage.getItem('token'))
                const config = {
                    headers: {
                        'Authorization': `Bearer ${token}`
                    }
                }
                axios.delete(url,config)
                .then(res => {
                    console.log(res);
                    localStorage.clear()
                    window.location.href='inscription'
                })
            }
        }
    }
</script>
<style scoped>
    * {
        color: white;
    }
    input{
        color: black;
        max-width: 100px;
        border: none;
        padding-left: 10px;
    }
    input[type = 'file']{
    display: none;
    }
    .custom-file-upload {
    height: 30px;
    max-width: 200px;
    border-radius: 15px;
    background: rgb(44, 52, 167);
    display: inline-block;
    text-align: center;
    cursor: pointer;
    align-self: center;
    color: white;
    padding: 2px 2px;
    }
    #image-user{
        width: 120px;
        height: 120px;
        background-color: beige;
        border-radius: 50%;
    }
    #profile-container {
        background: rgb(36, 36, 36);
        max-width: 500px;
        min-width: 300px;
        border-radius: 25px;
        margin: auto;
        align-self: center;
    }
    .btn-edit{
    background-color: rgb(44, 52, 167);
    border-radius: 5px;
    }
    .little-font{
        font-size: small;
    }
    h1 {
        color: white;
        font-size: 25px;
    }
    .btn-delete{
    background-color: rgb(167, 44, 44);
    border-radius: 5px;
    }
    .cuted-text{
    text-overflow: ellipsis;
    overflow: hidden;
    white-space: nowrap;
    max-width: 200px;
}
</style>